import * as plugins from './spark.plugins.js';
import { SparkTaskManager } from './spark.classes.taskmanager.js';
import { SparkInfo } from './spark.classes.info.js';
import { SparkUpdateManager } from './spark.classes.updatemanager.js';
import { logger } from './spark.logging.js';
import { SparkLocalConfig } from './spark.classes.localconfig.js';

export class Spark {
  public smartdaemon: plugins.smartdaemon.SmartDaemon;
  public sparkLocalConfig: SparkLocalConfig;
  public sparkTaskManager: SparkTaskManager;
  public sparkInfo: SparkInfo;
  public sparkUpdateManager: SparkUpdateManager;

  constructor() {
    this.smartdaemon = new plugins.smartdaemon.SmartDaemon();
    this.sparkLocalConfig = new SparkLocalConfig(this);
    this.sparkInfo = new SparkInfo(this);
    this.sparkTaskManager = new SparkTaskManager(this);
    this.sparkUpdateManager = new SparkUpdateManager(this);
  }

  public async daemonStart() {
    await this.sparkUpdateManager.start();
    this.sparkTaskManager.start();
  }
}
